# -*- coding: utf-8 -*-
# ------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
# ------------------------------------------------------------
import urlparse
import string
import re
import os
import sys
import io

from core import logger
from core import config
from core import scrapertools
from core import jsontools

from core.item import Item
from servers import servertools
from channelselector import get_thumbnail_path
from lib import requests

__channel__ = "seriesblanco"
__category__ = "F"
__type__ = "generic"
__title__ = "Series Blanco"
__language__ = "ES"


HOST = "http://seriesblanco.com/"
IDIOMAS = {'es': 'Español', 'la': 'Latino', 'vos': 'VOS', 'vo': 'VO', 'japovose': 'VOSE'}
CALIDADES = ['SD', 'HDiTunes', 'Micro-HD-720p', 'Micro-HD-1080p', '1080p', '720p']
DEBUG = config.get_setting("debug")

# TODO EXTRAER LO QUE NO VA AQUI Y MODULARIZARLO
# TODO MEJORAR LOS MENUS, HACERLO CON JSON O CON SETTINGS??
# todo mejorar tema de colores
# TODO mejorar logger
# TODO meter explicaciones en "Plot"
# todo echar un ojo a los .strip() y lower() que algunos son redundantes
# todo cuidado con el tema de los nombres raros de serie...
# todo documentar metodos
# todo meter try/catch
# todo echar un ojo a https://pyformat.info/, se puede formatear el estilo y hacer referencias directamente a elementos
# todo añadir thumbnails, fanart


# Cargar los datos con la librería 'requests'
def get_page(url):

    response = requests.get(url)
    return response.status_code, response.content


def isGeneric():
    return True


def mainlist(item):
    logger.info("pelisalacarta.seriesblanco mainlist")

    thumb_series = get_thumbnail("thumb_canales_series.png")
    thumb_series_az = get_thumbnail("thumb_canales_series_az.png")
    thumb_buscar = get_thumbnail("thumb_buscar.png")

    itemlist = list([])
    itemlist.append(Item(channel=__channel__, title="Series Listado Alfabetico", action="series_listado_alfabetico",
                         thumbnail=thumb_series_az))
    itemlist.append(Item(channel=__channel__, title="Todas las Series", action="series",
                         url=urlparse.urljoin(HOST, "lista_series/"), thumbnail=thumb_series))
    itemlist.append(Item(channel=__channel__, title="Buscar...", action="search", url=HOST, thumbnail=thumb_buscar))
    itemlist.append(Item(channel=__channel__, title="[COLOR yellow]Configurar filtro para series...[/COLOR]",
                         action="mainlist_filter"))
    # itemlist.append(Item(channel="channelselector", title="volver a [Listado de canales]", action="listchannels",
    #                      category="S"))

    # prueba()

    return itemlist


def mainlist_filter(item):
    logger.info("pelisalacarta.seriesblanco mainlist_filter")

    itemlist = list([])
    dict_series = get_filtered_shows()

    itemlist.append(Item(channel=__channel__, action="mainlist", title="[COLOR white][Menú Principal][/COLOR]"))
    itemlist.append(Item(channel=__channel__, action="add_filter", title="Añade una serie...", extra=str(dict_series)))

    for idx, key in enumerate(dict_series.keys()):
        tag_color = "green"
        if idx % 2 == 0:
            tag_color = "blue"

        title = "Configurar [COLOR {0}][{1}][/COLOR]".format(tag_color, string.capwords(key))
        extra = "{0}##{1}##{2}".format(str(dict_series), key, str(dict_series[key]))

        itemlist.append(Item(channel=__channel__, action="config_filter", title=title,
                             extra=extra))

    return itemlist


def add_filter(item):
    logger.info("pelisalacarta.seriesblanco add_filter")

    itemlist = list([])
    itemlist.append(Item(channel=__channel__, title="Series Listado Alfabetico", action="series_listado_alfabetico",
                         extra=item.extra))
    itemlist.append(Item(channel=__channel__, title="Todas las Series", action="series",
                         url=urlparse.urljoin(HOST, "lista_series/"), extra=item.extra))
    itemlist.append(Item(channel=__channel__, title="Buscar...", action="search", url=HOST, extra=item.extra))

    return itemlist


def config_filter(item):
    logger.info("pelisalacarta.seriesblanco config_filter")

    itemlist = list([])

    filter_list = item.extra.split("##")
    name = string.capwords(item.title.strip())
    dict_filter = '{"calidad_no_permitida":[], "idioma": ""}'
    idioma = ""
    calidad_no_permitida = ""

    if len(filter_list) > 1:
        name = string.capwords(filter_list[1])
    if len(filter_list) > 2:
        dict_filter = eval(filter_list[2])
        if dict_filter["idioma"]:
            logger.info("confI {0}".format(dict_filter["idioma"]))
            idioma = IDIOMAS[dict_filter["idioma"]]
        if dict_filter["calidad_no_permitida"]:
            calidad_no_permitida = ", ".join(dict_filter["calidad_no_permitida"])

    extra = "{0}##{1}##{2}".format(filter_list[0], name.lower(), str(dict_filter))
    # logger.info("extra {0}".format(extra))

    title = "Serie: [COLOR yellow]{0}[/COLOR]".format(name)
    itemlist.append(Item(channel=__channel__, action="config_filter", title=title, extra=extra))
    title = "[COLOR green]GUARDAR[/COLOR]:"
    itemlist.append(Item(channel=__channel__, action="save_filter", title=title, extra=extra))
    title = "Cambiar idioma: {0}".format(idioma)
    itemlist.append(Item(channel=__channel__, action="config_lang", title=title, extra=extra))
    title = "Cambiar calidad no permitida: {0}".format(calidad_no_permitida.upper())
    itemlist.append(Item(channel=__channel__, action="config_quality", title=title, extra=extra))

    dict_series = eval(filter_list[0])
    if name.lower() in dict_series.keys():
        itemlist.append(Item(channel=__channel__, action="del_filter", title="[COLOR red]Borrar Filtro[/COLOR]",
                             extra=extra))

    return itemlist


def config_lang(item):
    logger.info("pelisalacarta.seriesblanco config_lang")

    itemlist = list([])
    # se divide el str a list
    filter_list = item.extra.split("##")
    # se convierte de str a dict
    dict_filter = eval(filter_list[2])

    for idioma in IDIOMAS.keys():
        dict_filter["idioma"] = idioma
        filter_list[2] = str(dict_filter)
        extra = "##".join(filter_list)
        itemlist.append(Item(channel=__channel__, action="config_filter", title=IDIOMAS[idioma], extra=extra))

    return itemlist


def config_quality(item):
    logger.info("pelisalacarta.seriesblanco config_quality")

    itemlist = list([])
    itemlist.append(Item(channel=__channel__, action="config_quality_by_search",
                         title="Teclee que calidad desea filtrar ", extra=item.extra))
    itemlist.append(Item(channel=__channel__, action="config_quality_by_itemlist", title="Listado de calidades ",
                         extra=item.extra))
    itemlist.append(Item(channel=__channel__, action="config_filter", title="Volver ", extra=item.extra))

    return itemlist


def config_quality_by_search(item):
    logger.info("pelisalacarta.seriesblanco config_quality_by_search")

    itemlist = list([])
    # se divide el str a list
    filter_list = item.extra.split("##")
    # se convierte de str a dict
    dict_filter = eval(filter_list[2])
    if dict_filter["calidad_no_permitida"]:
        # el list dict_filter["calidad_no_permitida"] lo convertimos a str y separado por ", "
        calidad_no_permitida = ", ".join(dict_filter["calidad_no_permitida"])
    else:
        # el list dict_filter["calidad_no_permitida"] está vacío
        calidad_no_permitida = ""

    logger.info("calidad_no_permitida " + calidad_no_permitida)

    import xbmc
    keyboard = xbmc.Keyboard(calidad_no_permitida.upper())
    keyboard.doModal()
    if keyboard.isConfirmed():
        tecleado = keyboard.getText()
        logger.info("teclado {0}".format(tecleado))
        # convertimos el str en list separados por "," y eliminamos los espacios al principio y final
        dict_filter["calidad_no_permitida"] = [x.strip().lower() for x in tecleado.split(",")]

        filter_list[2] = str(dict_filter)
        extra = "##".join(filter_list)

        itemlist.append(Item(channel=__channel__, action="config_filter",
                             title="Pulse si no quiere esta calidad [COLOR yellow][{0}][/COLOR]".format(tecleado),
                             extra=extra))
    else:
        itemlist = []

    return itemlist


def config_quality_by_itemlist(item):
    logger.info("pelisalacarta.seriesblanco config_quality_by_itemlist")

    itemlist = list([])
    # se divide el str a list
    filter_list = item.extra.split("##")
    # se convierte de str a dict
    dict_filter = eval(filter_list[2])

    for element in sorted(CALIDADES, key=str.lower):

        marcado = "[  ]"
        color = "[COLOR]"
        if element.lower() in dict_filter["calidad_no_permitida"]:
            marcado = "[X]"
            color = "[COLOR red]"

        extra = "##".join(filter_list)
        logger.info("extra sin element: {0}".format(extra))
        extra = "{0}##{1}".format(extra, element.lower())
        # logger.info("extra CON element: {0}".format(extra))
        itemlist.append(Item(channel=__channel__, action="menu_yes_no",
                             title="{0}{1:_<20}{2:>4}[/COLOR]".format(color, element, marcado), extra=extra))
        logger.info("element:{0} marcado:{1} y dict_cfg_ql[calidad_no_permitida]:{2}"
                    .format(element, marcado, dict_filter["calidad_no_permitida"]))

    itemlist.append(Item(channel=__channel__, action="config_filter", title="Volver ",
                         extra=extra))

    return itemlist


def menu_yes_no(item):
    logger.info("pelisalacarta.seriesblanco menu_yes_no")
    itemlist = []

    # se divide el str a list
    filter_list = item.extra.split("##")
    # se convierte de str a dict
    dict_filter = eval(filter_list[2])

    if dict_filter["calidad_no_permitida"]:
        # logger.info("soy diccionario EN SI: {0}".format(dict_filter["calidad_no_permitida"]))
        # se converte a set para evitar que si exista el elemento, se inserte en la lista y se vuelve a tipo list
        set_filter = set(dict_filter["calidad_no_permitida"])
        set_filter.add(filter_list[3])
        dict_filter["calidad_no_permitida"] = list(set_filter)
    else:
        # el list json_cfg_ql["calidad_no_permitida"] está vacío
        # logger.info("estoy vacio: {0}".format(dict_filter["calidad_no_permitida"]))
        dict_filter["calidad_no_permitida"].append(filter_list[3])

    filter_list[2] = str(dict_filter)
    extra = "##".join(filter_list[:-1])
    logger.info("extra SI{0} ".format(extra))
    itemlist.append(Item(channel=__channel__, action="config_quality_by_itemlist", title="NO PERMITIR: {0}"
                         .format(filter_list[3].upper()), extra=extra))

    if dict_filter["calidad_no_permitida"]:
        logger.info("soy diccionario EN NO: {0}".format(dict_filter["calidad_no_permitida"]))
        if type(dict_filter["calidad_no_permitida"]) is list:
            dict_filter["calidad_no_permitida"].remove(filter_list[3])
        else:
            dict_filter["calidad_no_permitida"] = []

    filter_list[2] = str(dict_filter)
    extra = "##".join(filter_list[:-1])
    logger.info("extra NO{0} ".format(extra))
    itemlist.append(Item(channel=__channel__, action="config_quality_by_itemlist", title="PERMITIR: {0}"
                         .format(filter_list[3].upper()), extra=extra))

    return itemlist


def save_filter(item):
    logger.info("pelisalacarta.seriesblanco save_filter")

    itemlist = list([])

    cadena = item.extra.split("##")
    dict_series = eval(cadena[0])
    dict_filter = eval(cadena[2])
    dict_series[cadena[1].strip().lower()] = dict_filter

    name_file = os.path.splitext(os.path.basename(__file__))[0]

    if not os.path.exists(os.path.join(config.get_data_path(), "channels")):
        os.mkdir(os.path.join(config.get_data_path(), "channels"))

    fname = os.path.join(config.get_data_path(), "channels", name_file + ".data.json")

    data = read_file(fname)
    dict_data = jsontools.load_json(data)

    # es un dict
    if dict_data:
        if "SERIES" in dict_data:
            logger.info("   existe el key SERIES")
            dict_data["SERIES"] = dict_series
        else:
            logger.info("   NO existe el key SERIES")
            new_dict = {"SERIES": dict_series}
            dict_data.update(new_dict)
    else:
        logger.info("   NO es un dict")
        dict_data = {"SERIES": dict_series}

    json_data = jsontools.dump_json(dict_data)

    title = "[COLOR green]FILTRO GUARDADO,[/COLOR] "
    title = save_file(json_data, fname, title)
    title += "pulse para volver al Listado"

    itemlist.append(Item(channel=__channel__, action="mainlist_filter", title=title))
    return itemlist


def del_filter(item):
    logger.info("pelisalacarta.seriesblanco del_filter")

    itemlist = list([])

    filter_list = item.extra.split("##")
    dict_series = eval(filter_list[0])
    key = filter_list[1].lower()

    title = "[COLOR green]FILTRO Borrado,[/COLOR] "
    try:
        del dict_series[key]

        name_file = os.path.splitext(os.path.basename(__file__))[0]
        fname = os.path.join(config.get_data_path(), "channels", name_file + ".data.json")

        # leemos el fichero de nuevo y actualizamos los datos
        data = read_file(fname)

        dict_data = eval(data)
        if "SERIES" in dict_data:
            dict_data["SERIES"] = dict_series
        else:
            dict_data = {"SERIES": dict_series}

        json_data = jsontools.dump_json(dict_data)
        title = save_file(json_data, fname, title)

    except KeyError:
        title = "[COLOR red]ERROR al borrar el filtro,[/COLOR] "

    title += "pulse para volver al Listado"

    itemlist.append(Item(channel=__channel__, action="mainlist_filter", title=title))
    return itemlist


def series_listado_alfabetico(item):
    logger.info("pelisalacarta.seriesblanco series_listado_alfabetico")

    itemlist = []

    for letra in ['0', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
                  'T', 'U', 'V', 'W', 'X', 'Y', 'Z']:
        itemlist.append(Item(channel=__channel__, action="series_por_letra", title=letra,
                             url=urlparse.urljoin(HOST, "series/{0}/buscar_letra.html".format(letra.upper())),
                             extra=item.extra))

    return itemlist


# La página de series por letra es igual que la de buscar
# así que abuso un poco de esa función con el parámetro extra
def series_por_letra(item):
    return search(item, '')


def search(item, texto):
    logger.info("[pelisalacarta.seriesblanco search texto={0}".format(texto))

    itemlist = []

    if texto != "":
        item.url = urlparse.urljoin(HOST, "/search.php?q1={0}".format(texto))

    status_code, data = get_page(item.url)
    logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(item.url))
    logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(status_code))

    if status_code == requests.codes.ok:

        data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;|<Br>|<BR>|<br>|<br/>|<br />|-\s", "", data)
        data = re.sub(r"<!--.*?-->", "", data)
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")

        '''
        <div style='float:left;width: 620px;'>
            <div style='float:left;width: 33%;text-align:center;'>
                <a href='/serie/20/against-the-wall.html' '>
                    <img class='ict' src='http://4.bp.blogspot.com/-LBERI18Cq-g/UTendDO7iNI/AAAAAAAAPrk/QGqjmfdDreQ/
                        s320/Against_the_Wall_Seriesdanko.jpg' alt='Capitulos de: Against The Wall' height='184'
                        width='120'>
                </a>
                <br>
                <div style='text-align:center;line-height:20px;height:20px;'>
                    <a href='/serie/20/against-the-wall.html' style='font-size: 11px;'> Against The Wall</a>
                </div>
                <br><br>
        '''
        patron = "<div style='text-align:center;line-height:20px;height:20px;'><a href='([^']+)' " \
                 "style='font-size: 11px;'>([^<]+)</a>"

        matches = re.compile(patron, re.DOTALL).findall(data)

        action = "episodios"
        if item.extra != "":
            action = "config_filter"

        for scrapedurl, scrapedtitle in matches:
            itemlist.append(Item(channel=__channel__, title=scrapedtitle, url=urlparse.urljoin(HOST, scrapedurl),
                                 action=action, show=scrapedtitle, extra=item.extra))

        try:
            return itemlist
        # Se captura la excepción, para no interrumpir al buscador global si un canal falla
        except:
            import sys
            for line in sys.exc_info():
                logger.error("{0}".format(line))
            return []

    else:
        itemlist.append(Item(channel=__channel__, action="mainlist",
                             title="No se ha podido cargar la pagina ERROR:{0}".format(status_code), url="",
                             thumbnail="", plot=""))

    return itemlist


def series(item):
    logger.info("pelisalacarta.seriesblanco series")

    itemlist = []

    status_code, data = get_page(item.url)
    if DEBUG:
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(item.url))
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(status_code))

    if status_code == requests.codes.ok:

        data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;|<Br>|<BR>|<br>|<br/>|<br />|-\s", "", data)
        data = re.sub(r"<!--.*?-->", "", data)
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")

        patron = "<li><a href='([^']+)' title='([^']+)'>[^<]+</a></li>"

        matches = re.compile(patron, re.DOTALL).findall(data)

        for scrapedurl, scrapedtitle in matches:
            action = "episodios"
            if item.extra != "":
                action = "config_filter"
            itemlist.append(Item(channel=__channel__, title=scrapedtitle, url=urlparse.urljoin(HOST, scrapedurl),
                                 action=action, show=scrapedtitle, extra=item.extra))
    else:
        itemlist.append(Item(channel=__channel__, action="mainlist",
                             title="No se ha podido cargar la pagina ERROR:{0}".format(status_code), url="",
                             thumbnail="", plot=""))

    return itemlist


def episodios(item):
    logger.info("pelisalacarta.seriesblanco episodios")

    itemlist = []

    status_code, data = get_page(item.url)
    if DEBUG:
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(item.url))
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(status_code))

    if status_code == requests.codes.ok:

        data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;|<Br>|<BR>|<br>|<br/>|<br />|-\s", "", data)
        data = re.sub(r"<!--.*?-->", "", data)
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")

        data = re.sub(r"a></td><td> <img src=/banderas/", "a><idioma/", data)
        data = re.sub(r"<img src=/banderas/", "|", data)
        data = re.sub(r"\.png border='\d+' height='\d+' width='\d+'[^>]+><", "/idioma><", data)
        data = re.sub(r"\.png border='\d+' height='\d+' width='\d+'[^>]+>", "", data)

        '''
        <td>
            <a href='/serie/534/temporada-1/capitulo-00/the-big-bang-theory.html'>1x00 - Capitulo 00 </a>
        </td>
        <td>
            <img src=/banderas/vo.png border='0' height='15' width='25' />
            <img src=/banderas/vos.png border='0' height='15' width='25' />
        </td>
        '''
        patron = "<a href='([^']+)'>([^<]+)</a><idioma/([^/]+)/idioma>"

        matches = re.compile(patron, re.DOTALL).findall(data)

        for scrapedurl, scrapedtitle, scrapedidioma in matches:
            idioma = ""
            for i in scrapedidioma.split("|"):
                idioma += " [{0}]".format(IDIOMAS[i])
            title = "{0} - {1}{2}".format(item.title, scrapedtitle, idioma)
            itemlist.append(Item(channel=__channel__, title=title, url=urlparse.urljoin(HOST, scrapedurl),
                                 action="findvideos", show=item.show))

        # Opción "Añadir esta serie a la biblioteca de XBMC"
        if config.get_library_support() and len(itemlist) > 0:
            itemlist.append(Item(channel=__channel__, title="Añadir esta serie a la biblioteca de XBMC", url=item.url,
                                 action="add_serie_to_library", extra="episodios", show=item.show))

    else:
        itemlist.append(Item(channel=__channel__, action="mainlist",
                             title="No se ha podido cargar la pagina ERROR:{0}".format(status_code), url="",
                             thumbnail="", plot=""))

    return itemlist


def findvideos(item):
    logger.info("pelisalacarta.seriesblanco findvideos")

    itemlist = []

    status_code, data = get_page(item.url)
    if DEBUG:
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(item.url))
        logger.info("pelisalacarta.channels.seriesblanco **** {0}".format(status_code))

    if status_code == requests.codes.ok:

        # Hacer la petición ajax con los enlaces
        params = scrapertools.get_match(data, 'data : "(action=load[^\"]+)"')
        data = scrapertools.cachePagePost(HOST + 'ajax.php', params)

        data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;|<Br>|<BR>|<br>|<br/>|<br />|-\s", "", data)
        data = re.sub(r"<!--.*?-->", "", data)
        data = unicode(data, "iso-8859-1", errors="replace").encode("utf-8")

        data = re.sub(r"<center>|</center>|</a>", "", data)
        data = re.sub(r'<div class="grid_content([^>]+)><span></span>', r'<div class="grid_content\1><span>SD</span>',
                      data)

        '''
        <td><div class="grid_content*ATTR*><span>(*FECHA*)</span></div></td>
        <td><div class="grid_content2*ATTR*><span><img src="*PATH*/(*IDIOMA*)\.*ATTR*></span></td>
        <td>
            <div class="grid_content*ATTR*>
                <span><a href="(*ENLACE*)"*ATTR*><img src='/servidores/(*SERVIDOR*).*ATTR*></span>
            </div>
        </td>
        <td><div class="grid_content*ATTR*><span>(*UPLOADER*)</span></td>
        <td><div class="grid_content*ATTR*><span>(*SUB|CALIDAD*)</span></td>
        '''

        online = scrapertools.get_match(data, '<table class="as_gridder_table">(.+?)</table>')
        download = scrapertools.get_match(data, '<div class="grid_heading"><h2>Descarga</h2></div>(.*)')

        online = re.sub(r"<td><div class=\"grid_content[^>]+><span>([^>]+)</span></div></td><td>" +
                        "<div class=\"grid_content2[^>]+><span><img src=\".+?banderas/([^\.]+)\.[^>]+></span></td>" +
                        "<td><div class=\"grid_content[^>]+><span><a href=\"([^\"]+)\"[^>]+>"
                        "<img src='/servidores/([^\.]+)\.[^>]+></span></div></td>" +
                        "<td><div class=\"grid_content[^>]+><span>([^>]+)</span></td>" +
                        "<td><div class=\"grid_content[^>]+><span>([^>]+)</span></td>",
                        r"<patron>\3;\2;\1;\4;\5;\6;Ver</patron>", online)

        download = re.sub(r"<td><div class=\"grid_content[^>]+><span>([^>]+)</span></div></td><td>" +
                          "<div class=\"grid_content2[^>]+><span><img src=\".+?banderas/([^\.]+)\.[^>]+></span></td>" +
                          "<td><div class=\"grid_content[^>]+><span><a href=\"([^\"]+)\"[^>]+>"
                          "<img src='/servidores/([^\.]+)\.[^>]+></span></div></td>" +
                          "<td><div class=\"grid_content[^>]+><span>([^>]+)</span></td>" +
                          "<td><div class=\"grid_content[^>]+><span>([^>]+)</span></td>",
                          r"<patron>\3;\2;\1;\4;\5;\6;Descargar</patron>", download)

        data = online+download

        '''
        <patron>*URL*;*IDIOMA*;*FECHA*;*SERVIDOR*;*UPLOADER*;*SUB|CALIDAD*;*TIPO*</patron>
        '''
        patron = '<patron>([^;]+);([^;]+);([^;]+);([^;]+);([^;]+);([^;]+);([^<]+)</patron>'
        matches = re.compile(patron, re.DOTALL).findall(data)

        lista_enlaces = list([])
        existe_filtro = False
        json_series = get_filtered_shows()

        if DEBUG:
            logger.info("show {0}".format(item.show.lower().strip()))

        if item.show.lower().strip() in json_series.keys():
            existe_filtro = True

        for scrapedurl, scrapedidioma, scrapedfecha, scrapedservidor, scrapeduploader, scrapedsubcalidad, scrapedtipo \
                in matches:
            title = "{0} en {1} [{2}] [{3}] ({4}: {5})".format(scrapedtipo, scrapedservidor, IDIOMAS[scrapedidioma],
                                                               scrapedsubcalidad, scrapeduploader, scrapedfecha)
            if DEBUG:
                logger.info("item.show: {0} | title: {1}".format(item.show, title))

            if existe_filtro:
                lista_enlaces.append(dict(title=title, url=scrapedurl, idioma=scrapedidioma, calidad=scrapedsubcalidad,
                                          serie=item.show))
            else:
                itemlist.append(Item(channel=__channel__, title=title, url=urlparse.urljoin(HOST, scrapedurl),
                                     action="play", show=item.show))

        if len(lista_enlaces) > 0:
            itemlist = get_filtered_links(lista_enlaces, json_series[item.show.lower().strip()])

    else:
        itemlist.append(Item(channel=__channel__, action="mainlist",
                             title="No se ha podido cargar la pagina ERROR:{0}".format(status_code), url="",
                             thumbnail="", plot=""))

    return itemlist


def play(item):
    logger.info("pelisalacarta.channels.seriesblanco play url={0}".format(item.url))

    data = scrapertools.cache_page(item.url)

    patron = "<input type='button' value='Ver o Descargar' onclick='window.open\(\"([^\"]+)\"\);'/>"
    url = scrapertools.find_single_match(data, patron)

    itemlist = servertools.find_video_items(data=url)

    for videoitem in itemlist:
        videoitem.title = item.title
        videoitem.channel = __channel__

    return itemlist


def get_thumbnail(thumb_name=None):
    img_path = config.get_runtime_path() + '/resources/images/squares'
    if thumb_name:
        file_path = os.path.join(img_path, thumb_name)
        if os.path.isfile(file_path):
            thumb_path = file_path
        else:
            thumb_path = urlparse.urljoin(get_thumbnail_path(), thumb_name)
    else:
        thumb_path = urlparse.urljoin(get_thumbnail_path(), thumb_name)

    return thumb_path


def get_filtered_links(lista_enlaces, conf):
    """
    Devuelve una lista de enlaces filtrados.

    :param lista_enlaces: lista de enlaces
    :type lista_enlaces: list[dict]
    :param conf: contiene las preferencias para filtrar los enlaces
    :type conf: dict
    :return: lista de Item
    :rtype: list[Item]
    """
    logger.info("pelisalacarta.channels.seriesblanco get_filtered_links")
    if DEBUG:
        logger.info("total de enlaces : {0}".format(len(lista_enlaces)))
        logger.info("conf datos: {0}".format(conf))

    itemlist = []
    lista_aux = []
    num_calidad = 0
    num_idioma = 0

    for enlace in lista_enlaces:

        is_valid_idioma = True
        if conf["idioma"] != '':
            # if DEBUG:
            #     logger.info("entra: idioma")

            if enlace["idioma"] == conf["idioma"]:
                num_idioma += 1
            else:
                is_valid_idioma = False

        is_valid_calidad = True
        if conf["calidad_no_permitida"]:
            # if DEBUG:
            #     logger.info("entra: calidad_no_permitida")

            if enlace["calidad"].lower() not in conf["calidad_no_permitida"]:
                num_calidad += 1
            else:
                is_valid_calidad = False

        if is_valid_idioma and is_valid_calidad:
            lista_aux.append(enlace)
            if DEBUG:
                logger.info(" -Enlace añadido")

        if DEBUG:
            logger.info(" idioma valido?: {0}, enlace['idioma']: {1}, conf['idioma']: {2}"
                        .format(is_valid_idioma, enlace["idioma"], conf["idioma"]))
            logger.info(" calidad valida?: {0}, enlace['calidad']: {1}, conf.['calidad_no_permitida']: {2}"
                        .format(is_valid_calidad, enlace["calidad"], conf["calidad_no_permitida"]))

    for enlace in lista_aux:
        itemlist.append(Item(channel=__channel__, title=enlace["title"], url=urlparse.urljoin(HOST, enlace["url"]),
                             action="play", show=enlace["serie"]))

    logger.info("ENLACES FILTRADOS: {0}/{1}, idioma[{2}]:{3}, calidad_no_permitida{4}:{5}"
                .format(len(itemlist), len(lista_enlaces), conf["idioma"], num_idioma, conf["calidad_no_permitida"],
                        num_calidad))

    if len(itemlist) == 0:
        # itemlist.append(Item(channel=__channel__, title="Obtener todos los servidores sin filtro",
        #                      url="", action="mainlist", show="kaka"))
        # itemlist = lista_enlaces
        itemlist.append(Item(channel=__channel__, action="mainlist",
                             title="[COLOR red]No se han encontrado enlaces con el filtro [{0}][/COLOR]"
                             .format(IDIOMAS[conf['idioma']]), url="", thumbnail="", plot=""))
        # TODO PONER TODOS LOS ENLACES A CONTINUACIÓN

    return itemlist


def get_filtered_shows():
    logger.info("pelisalacarta.channels.seriesblanco get_filtered_shows")
    dict_series = {}
    # TODO cambiar name_file por __channel__???
    name_file = os.path.splitext(os.path.basename(__file__))[0]

    if not os.path.exists(os.path.join(config.get_data_path(), "channels")):
        os.mkdir(os.path.join(config.get_data_path(), "channels"))

    fname = os.path.join(config.get_data_path(), "channels", name_file + ".data.json")

    data = read_file(fname)
    dict_data = jsontools.load_json(data)

    check_json_file(data, fname, dict_data)

    if "SERIES" in dict_data:
        dict_series = dict_data["SERIES"]

        # TODO esto se deberia quitar, ya que se deberia guardar los keys con minusculas
        # ponemos en minusculas el key, ya que usamos el nombre de la serie como key.
        for key in dict_series.keys():
            new_key = key.lower()
            if new_key != key:
                dict_series[new_key] = dict_series[key]
                del dict_series[key]

    if DEBUG:
        logger.info("json_series: {0}".format(dict_series))

    return dict_series


def check_json_file(data, fname, dict_data):
    """
    Comprueba que si dict_data(conversion del fichero JSON a dict) no es un diccionario, se genere un fichero con
    data de nombre fname.bk.

    :param data: contenido del fichero fname
    :type data: str
    :param fname: nombre del fichero leido
    :type fname: str
    :param dict_data: nombre del diccionario
    :type dict_data: dict
    """
    if not dict_data:
        logger.info("Error al cargar el json del fichero {0}".format(fname))

        if data != "":
            # se crea un nuevo fichero
            title = save_file(data, "{0}.bk".format(fname), "")
            if title != "":
                logger.info("Ha habido un error al guardar el fichero: {0}.bk"
                            .format(fname))
            else:
                logger.info("Se ha guardado una copia con el nombre: {0}.bk"
                            .format(fname))
        else:
            logger.info("Está vacío el fichero: {0}".format(fname))


def read_file(fname):
    data = ""

    if os.path.isfile(fname):
        try:
            infile = open(fname, "r")
            data = infile.read()
            infile.close()
        except IOError:
            logger("ERROR al leer el archivo: {0}".format(fname))

    return data


def save_file(data, fname, title):
    try:
        with io.open(fname, "w", encoding="utf-8") as f:
            f.write(unicode(data))
        # f = io.open(fname, "w", encoding='utf-8')
        logger.info("datos a salvar {0}".format(data))
        # f.write(data)
        # f.close()
    except IOError:
        title = "[COLOR red]ERROR al guardar en disco,[/COLOR] "
    return title
